
void next_timeframe();
void set_inputs();
extern const unsigned int bound;

struct module_top {
unsigned __CPROVER_bitvector[8] x0_in,x1_in,x2_in,x3_in;
unsigned __CPROVER_bitvector[8] xavg_out,xdiff_out,xavg_next,xsum_next;
_Bool rst;
};

extern const struct module_top top;

//unsigned int expected_xavg(sx0,sx1,sx2,sx3){
  // unsigned int sx0,sx1,sx2,sx3, result;
  // result = (sx0+sx1+sx2+sx3)>>2;
 //  return (result);}

//unsigned int expected_xdiff(sx0,sx1,sx2,sx3){
  // unsigned int sx0,sx1,sx2,sx3;
  // unsigned int xavg = expected_xavg(sx0,sx1,sx2,sx3);
  // return ((xavg >= sx3)?(xavg - sx3):(sx3 - xavg));}

int main() {
unsigned int cycle;
unsigned __CPROVER_bitvector[8] sx0,sx1,sx2,sx3;
signed __CPROVER_bitvector[8] check_xsum_next;
unsigned int exp_xavg;
unsigned int exp_diff;

 //time-frame=0
 //__CPROVER_assume(top.rst);
top.rst = 1;
set_inputs();

next_timeframe(); //reset outputs

check_xsum_next = top.xsum_next;
//time-frame=1
//__CPROVER_assume(!top.rst);
top.rst = 0;

for(cycle=1; cycle<bound; cycle++) {
//capture inputs @ cycle=i into c-variables
top.x0_in = sx0; top.x1_in = sx1; top.x2_in = sx2; top.x3_in = sx3; 
set_inputs();
next_timeframe(); 
//check outputs @ cycle=i+1
//unsigned int exp_xavg = expected_xavg(sx0,sx1,sx2,sx3);
exp_xavg = (sx0+sx1+sx2+sx3)>>2;
exp_diff = (exp_xavg >= sx3)?(exp_xavg - sx3):(sx3 - exp_xavg);
//__CPROVER_assert(0, "test");
__CPROVER_assert((top.xavg_out == exp_xavg) &
      (top.xdiff_out == exp_diff), "check results"); //expected_xdiff(sx0,sx1,sx2,sx3))); 
//__CPROVER_assume(!top.rst);
top.rst = 0;
set_inputs();
};
}

